// chain.h: interface for the chain class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHAIN_H__E5EE42F2_21DD_11D5_849F_00A0C9E4283F__INCLUDED_)
#define AFX_CHAIN_H__E5EE42F2_21DD_11D5_849F_00A0C9E4283F__INCLUDED_

#include "haplist.h"	// Added by ClassView
#include "imat.h"	    // Added by ClassView
#include "haplotypes.h"	// Added by ClassView
#include "ctsdistribution.h"
#include "missing.h"
#include "raggedi.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class var: public ivec {
public:
	var(imat &g);
    var();
	int operator() (){return _nvar;}
	var &operator=(const var &a);
	int nvar(){return _nvar;}
 private:
	int _nvar;
};

class chain  
{
	friend class results;
public:
	double &temper(){return _tempering;};
	void printres(ostream &o);
	int updatehaps(int n, rng &r=globalrandom);
	bool updatealpha(rng &r=globalrandom);
	bool metromissing(rng &r=globalrandom);
    int updatemissing(int n, rng &r);
	void printgeno(ostream &o);
	void printfreq(ostream &o);
	chain(imat &d,iragged ph,ctsdistribution *ap, double tempering=1.0);
	chain(void);
	virtual ~chain();
	bool update(rng &r);
	int n(){return hl.n();}
	int samples(){return _samples;}
	double &alpha(){return _alpha;}
	void samplealpha(){_alpha = alphaprior->sample();} 
	double posterior(void);
//
	chain &operator=(const chain &a);
	int nmissing(){return _miss.nmissing();}
	bool miss() {return _miss();}
	//
	bool check(char *message);
private:	
	var variable;	
	missing _miss;	
	imat data;	  	
	double _tempering;	
	haplotypes haps;
	haplist hl;
	int _samples;
	double _alpha;
	ctsdistribution *alphaprior;
	iragged phase;
};
int metro_temper(chain *c,int nchains, ivec &order,rng &r=globalrandom);
#endif // !defined(AFX_CHAIN_H__E5EE42F2_21DD_11D5_849F_00A0C9E4283F__INCLUDED_)
