// haplist.h: interface for the haplist class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HAPLIST_H__8F379E86_1F93_11D5_849F_00A0C9E4283F__INCLUDED_)
#define AFX_HAPLIST_H__8F379E86_1F93_11D5_849F_00A0C9E4283F__INCLUDED_
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <map>
#include <iostream>
#include "random.h"
#include "haplotypes.h"
#include "imat.h"
using namespace::std;

//
//  hapfreq is a map structure
//  indexed by haplotype
//
typedef map<haplotype,int> hapfreq;

class haplist {	
public:
	double posterior(double alpha);
	haplotype maxfreq();
	haplist(haplotypes &ht);
	haplist():n_(0){};
	int add(const haplotype &a);
	int count(haplotype &a){return A.count(a);};
	int remove(const haplotype &r);
	haplotype hap(int i);
	virtual ~haplist();
	int n() {return n_;}
	
	int calcn();
	void print(ostream &o, int replicates=0);
	//
	int operator[](haplotype &c) {return A[c];} 
	haplist &operator=(const haplist &a);
	dvec frequencies(haplotypes &h);
private:
	int n_;
	hapfreq A;
};

#endif
