// haplotypes.h: interface for the haplotypes class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HAPLOTYPES_H__8F379E85_1F93_11D5_849F_00A0C9E4283F__INCLUDED_)
#define AFX_HAPLOTYPES_H__8F379E85_1F93_11D5_849F_00A0C9E4283F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ivec.h"
#include "imat.h"
#include "random.h"
#include "raggedi.h"
//
//  haplotype is just a redefinition of 
//  ivector that is slightly altered to 
//
class haplotype : public ivec
{
public:	
	haplotype(int *x, int len):ivec(x,len){};
	haplotype(haplotype &other,int *x);// gets the other haplotype
	haplotype();
	haplotype(int n):ivec(n){};
	~haplotype();
};

class haplotypes : public imat  
{
public:
	void change(int which , haplotype &h1, haplotype &h2);
	haplotypes(ivec &data, rng &r=globalrandom);
	haplotypes(imat &data, rng &r=globalrandom);
	haplotypes(imat &data,int extremal);
	void getold(int which, haplotype &h1, haplotype &h2);
	haplotypes();
	virtual ~haplotypes();
	//
	haplotypes &operator=(const haplotypes &a);
};
haplotypes allhaps(int *data,int loci);
void getnew(haplotype &h1, haplotype &h2,int *data,rng &r=globalrandom);
void getnewphase(haplotype &h1, haplotype &h2, 
		 int  *data,iragged &phase, rng &r=globalrandom);
bool isvariable(int *data, int loci);
ostream& operator <<(ostream &o,const haplotype &d);
bool operator<(const haplotype &lhs,const  haplotype &rhs);
bool operator<=(const haplotype &a,const  haplotype &b);
bool operator>(const haplotype &a,const  haplotype &b);
bool operator>=(const haplotype &a,const  haplotype &b);
bool operator==(const haplotype &a,const  haplotype &b);
bool operator!=(const haplotype &a,const  haplotype &b);

#endif // !defined(AFX_HAPLOTYPES_H__8F379E85_1F93_11D5_849F_00A0C9E4283F__INCLUDED_)
