#include <fstream>
#include "input.h"
#include "util.h"
#include "myio.h"
using namespace::std;	
//
//
input::~input()
{
  if (datafile)		delete [] datafile;
}
//
//
//
input::input(char *filename)
{
  ifstream in(filename);
  if (in==0) error("error unable to open input file");

  burnin	      =	scan(in,"burn-in",100);
  thinning	      =	scan(in,"thinning",100);
  samples	      =	scan(in,"samples",1000);
  chains	      =	scan(in,"chains",1);
  seed		      =	scan(in,"seed",1);

  datafile      =	namescan(in,"datafile","datafile");
  labelfile	=	namescan(in,"labelfile",NULL);
  phasefile     =       namescan(in,"phasefile",NULL);
  alphaprior    =       parscan(in,"alphaprior","uniform(1,1000)");
}
//
//
//
ostream &operator<<(ostream &o,input &m) 
{
  o << "burn-in: "	<< m.burnin		<< endl;
  o << "samples: "	<< m.samples	<< endl;	
  o << "thinning: "	<< m.thinning	<< endl;
  o << "chains: "	<< m.chains		<< endl;
  o << "seed: "		<< m.seed		<< endl;
  o << endl;
  o << "datafile: "	<< m.datafile	<< endl;
  if (m.labelfile)
    o << "labelfile: "	<< m.labelfile	<< endl;
  if (m.phasefile)
    o << "phasefile: "  << m.phasefile << endl;
  o << "alphaprior: "   << *m.alphaprior<<endl;
  o << endl;
  return o;
}
//
//
const char *input::check()
{
  // a static message - just holds the last one
  static char c[1023];
	
  if (burnin<0)  return "burn-in must be positive";
  if (samples<1) return "samples must be at leat one";
  if (chains<1||chains>10) return "nchains must be in the range 1 to 10";
  if (seed<0) return "seed should be greater than 0";
  return NULL;
}

