#include "missing.h"
//
//  Constructor
//
void unvar(imat &g,rng &r)
{
	for (int i=1;i<=g.rows();i++) {
		for (int j=1;j<=g.columns()/2;j++) {
			if (g[i][2*j-1]<0) {
				if (g[i][2*j]>=0) 
					error e("problem in data file\n"
					"if one gene at a locus is missing so is the other\n");
				g[i][2*j-1] = r.rint(1,2);
				g[i][2*j] = r.rint(1,2);
			}
		}
	}
}
//
//
//
missing::missing(imat &g)
{ 
	int i,j;
	_nmissing=0;
	
	for ( i=1;i<=g.rows();i++) {
		for ( j=1;j<=g.columns()/2;j++) if (g[i][2*j]<0) _nmissing++;
	}
	if (_nmissing>0) {
		missing_ind.allocate(_nmissing);
		missing_locus.allocate(_nmissing);
		int count=0;
		for ( i=1;i<=g.rows();i++) {
			for ( j=1;j<=g.columns()/2;j++) {
				if (g[i][2*j]<0) {
					missing_ind[++count]=i;
					missing_locus[count]=j;
				}
			}
		}
	}
	unvar(g);
}
//
missing::missing()
{
	_nmissing=0;
}
//
//
//
missing::~missing()
{
	_nmissing=0;
}

missing &missing::operator =(const missing &m)
{
  if (this==&m) return *this;
  _nmissing=m._nmissing;
  missing_ind=m.missing_ind;
  missing_locus=m.missing_locus;
  return *this;
}

gpair missing::rndmissing(rng &r)
{
  gpair g;
  int wh=r.rint(1,_nmissing);
  g.locus=missing_locus[wh];
  g.individual=missing_ind[wh];
  return g;
}
//
//
//
int missing::nmissing()
{
  return _nmissing;
}
//
//
missing::missing(const missing &m)
{
	cerr << "here -1b\n";
	_nmissing=m._nmissing;
	missing_ind=m.missing_ind;
	missing_locus=m.missing_locus;
}
