#include <iostream>
#include <fstream>
#include <strstream>
#include <cctype>
#include "ctsdistribution.h"
#include "myio.h"
#include "dvec.h"

using namespace::std;
//
// Functions for the distributions
//
ctsdistribution *scan(istream &in)
{
	char name[40];
	
    if (!nextname(in,name)) {
		cerr << "looking for " << name ; 
		cerr << "we need a continuous distribution";
		exit(0);
	}
	if (isdigit(name[0])) {
		double par=(double)atof(name);
		constant *x =new constant(par);// = new constant(par);
		return x;
	} else 	if (strcmp("uniform",name)==0) {
		int ch=in.get();
		if (ch!='(') {
			uniform *x = new uniform(1.0,-1.0);
			return x;
		} else {
			in.putback(ch);
			dvec par = get_doublesfrombrackets(in);
			uniform *x = new uniform(par[1],par[2]);
			return x;
		}
	} else if (strcmp("undefined",name)==0) {
		undefctsdist *x = new undefctsdist;
		return x;
	} else {
		dvec par = get_doublesfrombrackets(in);
		if (strcmp("normal",name)==0) {
			normal *x = new normal(par[1],par[2]);
			return x;
		} else if (strcmp("gamma",name)==0) {
			gammad *x = new gammad(par[1],par[2]);
			return x; 
		} else if (strcmp("lognormal",name)==0) {
			lognormal *x = new lognormal(par[1],par[2]);
			return x;
		} else if (strcmp("beta",name)==0) {
			beta *x=new beta(par[1],par[2]);
			return x;
		} else {
			cerr << "distribution "<<name<<" not recognised\n";
			exit(0);
		}
	}
}

//
ctsdistribution *parscan(istream &in, const char *namestring,char default_val[])
{
    if (findparametername(in,namestring)) {
	    return scan(in);
    } else {  
      istrstream in2(default_val);     
      cerr << namestring 
	   << " not found in parameter file, using "
	   << default_val << endl;
      return scan(in2);
    }
}
//
//
//
ostream &operator<<(ostream &o, const ctsdistribution &x)
 {
	return x.print(o);
}
