// imat.h: interface for the imat class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(DMAT_H__)
#define DMAT_H___

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <cassert>
#include <iostream>
using namespace::std;
class dvec;

class dmat  
{
public:
	dmat(dvec d, int rows, int columns, bool byrow=true);
	dmat(const char *filename,bool byrow=true);
	~dmat();
	dmat(int rows, int columns);
	dmat(int rows, int columns, double init);

    double & operator ()(int i, int j);
	double *operator ()(int i);
	double *operator [](int i);
	int columns(void){return _cols;}
	int rows(void){return _rows;}
	//
	double &val(int i, int j);
	//
    void print(ostream &o);
private:	
	dmat(){}
	void allocate(int rows,int columns);
	int _cols;
	int _rows;
	double * _data;
};

ostream &operator << (ostream &o, dmat &x);

#endif 

