// dvec.h: interface for the dvec class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DVEC_H__2A775263_F9EC_11D4_AC6A_C9FF5D34BFCC__INCLUDED_)
#define AFX_DVEC_H__2A775263_F9EC_11D4_AC6A_C9FF5D34BFCC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <iostream>
#include <cassert>
#include <cmath>
using namespace::std;
class ctsdistribution;
//  A utility class for 
//  1..n indexed vectors of doubles
// including functions for means, means and variances
// and sums
class dvec  
{
public:
	double sum();
	double sum(int n);
	double mean();
	void avevar(double &ave, double &var);
	dvec(const dvec &d);
	dvec(ctsdistribution &d,int n);
	void reallocate(int len, double init);
	int length(void);
	int length(void) const {return _length;}
	dvec(int len);
	dvec(int len, const double init);
	~dvec();
	double & operator ()(int i);
	double & operator [](int i);
	double & operator [](int i) const;
	void operator += (double a){for (int i=0;i<_length;i++) *(_data+i)+=a;};
	double *data(){ return _data;};
	const dvec &operator=(const dvec &a) ;
	void operator *=(const double &a);
	void operator /=(const double &a);
	void operator *=(const dvec &a);

	void dexp(){for (int i=0;i<_length;i++) *(_data+i)=exp(*(_data+i));};
	void diff(double first=0.0);
	void sort();
private:
	dvec(void){_length=0;};
	int _length;	// length of the array
	double * _data;	// the data
};
ostream& operator <<(ostream &o,const dvec &d);
dvec operator+(const dvec &a, const dvec &b) ;
dvec operator*(const dvec &a, const dvec &b);
dvec operator/(const dvec &a, const dvec &b);

dvec readdoubles(istream &in, char until='\n');
istream &operator>>(istream &in, dvec &a);
dvec get_doublesfrombrackets(istream &in);

dvec scan(istream &in, char *namestring, dvec &default_val);
#endif 
