// factor.cpp: implementation of the factor class.
//
//////////////////////////////////////////////////////////////////////
#include "util.h"
#include "factor.h"
#include <cassert>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

factor::factor(const ivec &a):ivec(a)
{
	getcode();
}

factor::factor(void):ivec()
{
}

factor &factor::operator=(const factor &a)
{
	if (this != &a) {
		ivec::operator=(a);   // call the base class assignment operator 
		code=a.code;
	}
	return *this;
}

void factor::getcode()
{
	int count = 0;
	for (int i=0;i<_length;i++) {
		pair <int,int> b(_data[i],count);
		pair<map_itor,bool> present = code.insert(b);
		_data[i]=present.first->second;
		if (present.second) count++;
	}    
	if (code.size()!=count) error e("incorrect number inserted");
}

void factor::printutil()
{
	cout << *this;
	map_itor i;
	for (i=code.begin();i!=code.end();i++) {
		cout << i->first<<" "<<i->second<<endl;
	}
	cout << endl;
}

factor::factor(char *filename):ivec(filename)
{
	getcode();
}

factor::~factor()
{
	
}

int factor::key(int i)
// a function to return the i-th key (zero offset)
// I must get a better way!!
{
	assert(i>=0&&i<code.size());
	map_itor mi;
	for (mi=code.begin();;++mi) {
		if (i==mi->second) return mi->first;
	}
	error e("should not get here in factor::key");
}
