#ifndef GENOTYPE_H_

#define GENOTYPE_H_

#include <cassert>

#include "ivec.h"

#include "imat.h"

//  first a way of defining a generic n-polid 

//  genotype

//  question:  is there any point in producing a diploid (ivec should cover haploids).

//

class gdata: public ivec {

public:

	gdata(int loci):ivec(loci){};

	int nloci(){return _length;};

};



class diploid: public gdata {

public:

	diploid(int loci):gdata(2*loci){};

};



class gmat: public imat {

public:

	gmat(const imat &a):imat(a){};

	gmat(int samples,int cols):imat(samples,cols){};

	int *d(int samp, int locus){return _data+_cols*(samp-1)+locus-1;};

	int samples() {return _rows;};

};



class dipmat: public gmat {

public:

	dipmat(const imat &a):gmat(a){};

	dipmat(int samples,int loci):gmat(samples,2*loci){};

};





class multiploid:public gdata {

public:

	multiploid(int loci,int samples, int ploidy=2);

	~multiploid();

	void assign(int loci,int samples, int ploidy=2);

	gdata &operator[](int locus);

	int *operator ()(int locus) {

		assert(locus>1&&locus<_nloci); 

		return (_data+_ploidy*(locus-1));

	};

	int operator()(int locus, int al) {

		assert(locus>1&&locus<_nloci);assert(al>0&&al<3);

		return *(_data+_ploidy*(locus-1)+(al-1));

	};

private:

	int *_data;

	int _nloci;

	int _ploidy;

};





#endif