// imat.h: interface for the imat class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IMAT_H__35F9D621_FAAD_11D4_AC6B_81CE897368A0__INCLUDED_)
#define AFX_IMAT_H__35F9D621_FAAD_11D4_AC6B_81CE897368A0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include <vector>
#include <iostream>
#include <cassert>
using namespace::std;
class ivec;

class imat {
public:
	imat(ivec d, int rows, int columns, bool byrow=true);
	imat(vector <int> &a, int columns, bool byrow=true);
	imat(char *filename,bool usechar=false,bool byrow=true);
	imat(const imat &a);
	imat(){_rows=0,_cols=0;}
	//
	imat subset(ivec &userows, ivec &usecolumns);
	void resize(int r,int c);
	~imat();
	imat(int rows, int columns);
	int & operator ()(int i, int j);
	imat &operator=(const imat &a);
	int columns(){return _cols;};
	int rows(){return _rows;};
	int *operator[](int i);
	int *operator()(int i);
	// get the genotype a[0],a[1] from individual ind at locus 
	int *geno(int ind, int locus){
		assert(ind>=1&&ind<=_rows);assert(locus>=1&&2*locus<=_cols);
		return _data+(ind-1)*(_cols) + 2*(locus-1);
	}
	int rowsum(int i);
	int colsum(int j);
	ivec rowsum();
	ivec colsum();
	void print(ostream &o); 
protected:		
	void allocate(int rows,int columns);
	int _cols;
	int _rows;
	int * _data;
};

ostream &operator << (ostream &o, imat &x);

#endif // !defined(AFX_IMAT_H__35F9D621_FAAD_11D4_AC6B_81CE897368A0__INCLUDED_)



