// ivec.h: interface for the ivec class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ivec_H__2A775263_F9EC_11D4_AC6A_C9FF5D34BFCC__INCLUDED_)
#define AFX_ivec_H__2A775263_F9EC_11D4_AC6A_C9FF5D34BFCC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <iostream>
using namespace::std;

class ivec  
{
public:
	double sum();
	int max();
	int isum();
    double mean();
	int length(void) const {return _length;}
// constructors	
	ivec(const ivec &d);
	ivec(int len){allocate(len);}
	ivec(int *data, int len) {allocate(len);assign(data);}
	ivec(ivec &x, int n);
	ivec(int len, int init){allocate(len);assign(init);};
	ivec(){_length=0;_data=0;}
	ivec(int from, int to ,int step);
	ivec(const char *filename);
	// dtor
	~ivec();
	// operators
	int & operator ()(int i);
	int & operator [](int i);
	int & operator [](int i) const;
	const ivec &operator=(const ivec &a) ;
	void operator *=(const int &a);
	void operator *=(const ivec &a);

    void allocate(int len);
	void reallocate(int len);
	void allocateseries(int len){ allocate(len);series(1,len);}
        void series(int begin, int end);
	void count(const ivec &c);
	void count0(const ivec &c);

	ivec rep(int rep_els, int rep_vec=1);
protected:
    void assign(int a){for (int i=0;i<_length;i++) _data[i]=a;}
	void assign(int *a){for (int i=0;i<_length;i++) _data[i]=a[i];}
	int _length;
	int * _data;
};
ostream& operator <<(ostream &o,const ivec &d);
istream &operator>>(istream &in, ivec &a);

ivec operator+(const ivec &a, const ivec &b) ;
ivec operator*(const ivec &a, const int b);
ivec operator*(const ivec &a, const ivec &b);
ivec operator/(const ivec &a, const ivec &b);

ivec scan(istream &in, char *namestring, ivec &default_val);
#endif 
