#include "raggedi.h"
#include <cassert>
//
//
//
iragged::iragged(int *x,int *len, int n, int totl)
{
  int i,count=0;
  for (i=0;i<_rows;i++) {
    _r[i]=_data+count;
    assert(len[i]>=0);
    _cols[i]=len[i];
    for (int j=0;j<len[i];j++,count++) _data[count]=x[count];
  }
  assert(count==totl);
}
//
iragged::iragged(const iragged &a)
{
  allocate(a._rows,a._totl);
  assign(a._cols,a._data);
}
//
iragged::iragged()
{
  _rows=_totl=0;
}
//
iragged::iragged(ivec &x)
  // function to get a ragged array from a vector
  // of "similarities"
  // eg  1 2 3 0 1 2 2 3 0 --> 
  // 1 -> 4
  // 1 -> 9
  // 2 -> 1 3
  // 3 -> 2 6 7
  // 2 ->  3 8
  // note that in this case a 0 indicates something different
  // to everything else, and all xeros come first
{
  ivec c(x.max()+1);
  c.count0(x);
  int n=c[1]+c.length()-1;
  allocate(n,x.length());  
  int *len = new int[n];
  int i,count=0;
  for (i=0;i<c(0);i++) len[count++]=1;
  for (i=2;i<=c.length();i++) len[count++]=c[i];
  count=0;
  int *data = new int[x.length()];
  for (i=0;i<c.length();i++) {
    for (int j=1;j<=x.length();j++) 
      if (x[j]==i) data[count++]=j;
  }
  allocate(n,x.length());  
  assign(len,data); 
}
iragged::~iragged()
{
  destroy();
}
//helper functions
void iragged::allocate(int n, int totl)
{
 assert(n>0);
 _rows=n;
 _totl=totl;
  _cols = new int[_rows];
  _data= new int[_totl];
  _r = new int * [_rows];
}
//
void iragged::assign(int *len, int *x)
{
int i,count=0;
  for (i=0;i<_rows;i++) {
    _r[i]=_data+count;
    assert(len[i]>=0);
    _cols[i]=len[i];
    for (int j=0;j<len[i];j++,count++) _data[count]=x[count];
  }
  assert(count==_totl);
}
//
void iragged::destroy()
{
  if (_rows>0) {
    delete [] _cols;
    delete [] _data;
    delete [] _r;
  }
  _rows=0;
  _totl=0;
}

iragged &iragged::operator=(const iragged &a)
{
 if (this==&a) return *this;
 destroy();
 allocate(a._rows,a._totl);
 assign(a._cols,a._data);
 return *this;
}
//
//
//
ostream &iragged::print(ostream &o)
{
  for (int i=1;i<=rows();i++) {
    for (int j=1;j<=cols(i);j++) 
      o << elem(i,j)<< " " ;
    o << endl;
  }
  return o;
}

//ostream &operator<<(ostream &o, const iragged &a)
//{/
//	return a.print(o);
//}
