#ifndef CPPUTIL_H_
#define CPPUTIL_H_
#include <cstdlib>
#include <cmath>
#include <iostream>

using namespace::std;

enum sex{male,female};

#ifdef WIN32
const double  M_PI = 3.14159265358979323846;
const double  M_LN2 =0.69314718055994530942;
double lgamma(double xx);
#endif

// some mathematical constants
const double  M_1_SQRT_2PI=	0.398942280401432677939946059934;
const double  LMY_SQRT_2PI =-0.918938533204672669540968854562;
const double  M_SQRT_32=	5.656854249492380195206754896838;

class error {
public:
	error(const char *text) {
		cerr << text;
		exit(-1);
	}
};

class lfactorial {
public:
	lfactorial() {
		for (int i=0;i<32;i++) a[i]=0.0;
	}
	double operator()(int n) {
		if (n<=1) return 0.0;
		if (n<=31) return a[n] ? a[n] : (a[n]=lgamma((double)(n+1)));	
		else return lgamma((double)(n+1));
	};
private:
	double a[32];
};


// functions
double max(double x, double y);
double max(double *x, int n);
// sorting
void hpsort(unsigned long n, double  ra[]);
void hpsort(unsigned long n, int ra[]);
// quantile calculation
void quantiles(double *res,double *x, int nx, double *p,int np);
// mathematical functions
double log_D(const double *b, int n);

// functionoids
extern lfactorial lfactrl;
#endif
